'\"
'\" Copyright (c) 1993 The Regents of the University of California.
'\" Copyright (c) 1994-1996 Sun Microsystems, Inc.
'\"
'\" See the file "license.terms" for information on usage and redistribution
'\" of this file, and for a DISCLAIMER OF ALL WARRANTIES.
'\" 
'\" SCCS: @(#) nreforeach.n 1.6 96/03/25 20:23:53
'\" 
.so man.macros
.TH nreforeach n 3.0 Nre "Tcl Package Commands"
.BS
'\" Note:  do not modify the .SH NAME line immediately below!
.SH NAME
nreforeach \- Iterate over all the regular expression matches in a string
.SH SYNOPSIS
\fBpackage require nre ?3.0?\fP
.sp
\fBnreforeach \fIvarname regexp string body\fR
.BE
.VS
.SH DESCRIPTION
.PP
The \fBnreforeach\fR command implements a loop where the loop variable
\fIvarname\fR takes on values from each match of \fIregexp\fR on \fIstring\fR.
The \fIbody\fR argument is a Tcl script. For each match \fIvarname\fR is
assigned the text that \fIregexp\fR matched in \fIstring\fR and then
calls the Tcl interpreter to execute \fIbody\fR.
.PP
If \fIregexp\fR contains ``()'' then each captured string will be lappended
to \fIvarname\fR. You can keep a
subexpression from being appended by using ``(?:)'' instead of ``()''.
.PP
See the \fBnrematch\fR man page for a description of regular expressions.
\fBnreforeach\fR is implemented using the \fBnrematch\fR command with
the \fB\-eval \-all\fR and \fB\-flatten\fR switches.
See the \fBnrematch\fR for details on how
you can create your own version of nreforeach with additional features.
.VE
.SH KEYWORDS
iteration, looping, nre, regular expression, string
